/*
 * Copyright (c) 1991 Old Dominion University.
 * Copyright (c) 1991 University of North Carolina at Chapel Hill.
 * All rights reserved.
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation.  Old Dominion University and the University of North
 * Carolina at Chapel Hill make no representations about the
 * suitability of this software for any purpose.  It is provided "as is"
 * without express or implied warranty.
 */

/*
	resources.h
	hardwired fallback resources similar to XTv file
*/
/*
 * Murray's additions to resources.h
 *
 * Position the buttons similar to my XTv, so that the token_info
 * button is placed in a meaningful way.
 */

String FallbackResources[] = {

"xtv.ttitle: XTV Main Control Panel",
"xtv*font: -adobe-courier-bold-r-normal--18-180-75-75-m-110-iso8859-1",
"xtv*resizable:TRUE",
"xtv*top:Rubber",
"xtv*bottom:Rubber",
"xtv*left: Rubber",
"xtv*right: Rubber",
"xtv*MainBox.foreground: White",
"xtv*MainBox.background:Blue",
"!",
"!xtv*MainBox.Password.label:Unused",
"!",
"!xtv*MainBox.Password.label: Set Password",
"!",
"!xtv*MainBox.Password.sensitive: FALSE",
"!xtv*MainBox.Password.fromVert: ToolPanel",
"!xtv*MainBox.QuitButton.fromHoriz: Password",
"xtv*MainBox.MessageLabel.label: Message from system:",
"xtv*MainBox.MessageLabel.fromVert:ToolPanel",
"xtv*MainBox.QuitButton.foreground: Yellow",
"xtv*MainBox.QuitButton.background: Red",
"xtv*MainBox.QuitButton.label: Exit XTV",
"xtv*MainBox.QuitButton.fromVert: ToolPanel",
"xtv*MainBox.QuitButton.fromHoriz: MessageLabel",
"!!",
"!",
"! Begin Murray Addition",
"!",
"xtv*MainBox.MessageBar.fromVert:MessageLabel",
"xtv*MainBox.MessageBar.height:200",
"xtv*MainBox.MessageBox.fromVert:MessageLabel",
"xtv*MainBox.MessageBox.height:200",
"xtv*MainBox.MessageBox.fromHoriz:MessageBar",
"!",
"! End Murray Addition",
"!",
"!!",
"!",
"!xtv*MainBox.TestButton.label: Unused",
"!",
"!xtv*MainBox.TestButton.label: Test",
"!",
"!xtv*MainBox.TestButton.fromVert: ToolPanel",
"!xtv*MainBox.TestButton.fromHoriz: QuitButton",
"xtv*PartPanel*foreground: Black",
"xtv*PartPanel*background: ivory",
"xtv*Chairman.label: Chairman is :",
"xtv*Chairman.height: 30",
"xtv*PartPanel.fromVert: Chairman",
"xtv*PartPanel.Label.label: [Participants] In Session No: ",
"xtv*PartPanel.Label.resizable: FALSE",
"xtv*PartPanel.Label.borderWidth:0",
"xtv*PartPanel.VPort.allowVert:TRUE",
"xtv*PartPanel.VPort.forceBars:TRUE",
"xtv*PartPanel.VPort.resizable:TRUE",
"xtv*PartPanel.VPort.fromVert: Label",
#ifdef rs6000
"xtv*PartPanel.VPort.height: 50",
"xtv*PartPanel.VPort.width: 400",
#else
"xtv*PartPanel.VPort.height: 36",
"xtv*PartPanel.VPort.width: 300",
#endif
"xtv*PartPanel.VPort.PartList.defaultColumns:2",
"xtv*PartPanel.VPort.PartList.forceColumns:TRUE",
"xtv*PartPanel.VPort.PartList.sensitive:FALSE",
"xtv*PartPanel.VPort.PartList.columnSpacing:20",
"!",
"!xtv*PartPanel.ViewOnly.label: Unused",
"!",
"!xtv*PartPanel.ViewOnly.label:View_Only",
"!",
"!xtv*PartPanel.ViewOnly.sensitive:FALSE",
"!xtv*PartPanel.ViewOnly.fromVert: VPort",
"!",
"!xtv*PartPanel.Talk.label: Talk",
"!",
"!xtv*PartPanel.Talk.label: Unused",
"!xtv*PartPanel.Talk.sensitive:FALSE",
"!xtv*PartPanel.Talk.fromHoriz: ViewOnly",
"!xtv*PartPanel.Talk.fromVert: VPort",
"!!",
"! Begin Murray Addition",
"!",
"xtv*PartPanel.InfoPart.label: Participant_Info",
"xtv*PartPanel.InfoPart.sensitive: FALSE",
"xtv*PartPanel.InfoPart.fromVert: VPort",
"!xtv*PartPanel.InfoPart.fromHoriz: DropPart",
"!",
"! End Murray Addition",
"!!",
"xtv*PartPanel.DropPart.label: Drop_Participant",
"xtv*PartPanel.DropPart.sensitive:FALSE",
"xtv*PartPanel.DropPart.fromHoriz: InfoPart",
"xtv*PartPanel.DropPart.fromVert: VPort",
"xtv*PartPanel.DropPart.foreground: Yellow",
"xtv*PartPanel.DropPart.background: Red",
"!",
"xtv*ToolPanel*foreground:Black",
"xtv*ToolPanel*background:cyan",
"xtv*ToolPanel.fromVert:PartPanel",
"xtv*ToolPanel.Label.label: [Tools]",
"xtv*ToolPanel.Label.borderWidth:0",
"xtv*ToolPanel.VPort.allowVert:TRUE",
"xtv*ToolPanel.VPort.forceBars:TRUE",
"xtv*ToolPanel.VPort.fromVert:Label",
#ifdef rs6000
"xtv*ToolPanel.VPort.height: 50",
"xtv*ToolPanel.VPort.width: 400",
#else
"xtv*ToolPanel.VPort.height: 36",
"xtv*ToolPanel.VPort.width: 300",
#endif
"xtv*ToolPanel.VPort.ToolList.defaultColumns:3",
"xtv*ToolPanel.VPort.ToolList.forceColumns:TRUE",
"xtv*ToolPanel.VPort.ToolList.sensitive:FALSE",
"! ",
"xtv*ToolPanel.GToken.label: Get_Floor",
"xtv*ToolPanel.GToken.sensitive:FALSE",
"xtv*ToolPanel.GToken.fromVert:VPort",
"xtv*ToolPanel.GToken.foreground: Black",
"xtv*ToolPanel.GToken.background: LightYellow",
"!",
"xtv*ToolPanel.DToken.label: Drop_Floor",
"xtv*ToolPanel.DToken.sensitive:FALSE",
"xtv*ToolPanel.DToken.fromVert: VPort",
"xtv*ToolPanel.DToken.fromHoriz: GToken",
"xtv*ToolPanel.DToken.foreground: Black",
"xtv*ToolPanel.DToken.background: LightYellow",
"!",
"xtv*ToolPanel.SToken.label: Snatch_Floor",
"xtv*ToolPanel.SToken.sensitive:FALSE",
"xtv*ToolPanel.SToken.fromVert: Label",
"xtv*ToolPanel.SToken.fromHoriz: VPort",
"xtv*ToolPanel.SToken.foreground: Yellow",
"xtv*ToolPanel.SToken.background: Red",
"!",
"xtv*ToolPanel.NewTool.label: New_Tool",
"xtv*ToolPanel.NewTool.sensitive:TRUE",
"xtv*ToolPanel.NewTool.fromVert: GToken",
"xtv*ToolPanel.NewTool.foreground: Red",
"xtv*ToolPanel.NewTool.background: LightYellow",
"!",
"xtv*ToolPanel.IToken.label: Floor_Info",
"xtv*ToolPanel.IToken.sensitive:FALSE",
"xtv*ToolPanel.IToken.fromVert: VPort",
"xtv*ToolPanel.IToken.fromHoriz: DToken",
"xtv*ToolPanel.IToken.foreground: Black",
"xtv*ToolPanel.IToken.background: White",
"!",
"xtv*ToolPanel.Join.label: Join_Tool",
"xtv*ToolPanel.Join.sensitive:TRUE",
"xtv*ToolPanel.Join.fromVert: DToken",
"xtv*ToolPanel.Join.fromHoriz: GToken",
"xtv*ToolPanel.Join.foreground: Blue",
"xtv*ToolPanel.Join.background: White",
"!",
"xtv*JoinParent.JoinToolLabel.label: [Tools]",
"xtv*JoinParent.JoinToolLabel.borderWidth:0",
"xtv*JoinParent.JoinToolViewPort.allowVert:TRUE",
"xtv*JoinParent.JoinToolViewPort.forceBars:TRUE",
"xtv*JoinParent.JoinToolViewPort.fromVert:JoinToolLabel",
"xtv*JoinParent.JoinToolViewPort.height: 50",
"xtv*JoinParent.JoinToolViewPort.width: 150",
"xtv*JoinParent.JoinToolViewPort.JoinToolList.defaultColumns:2",
"xtv*JoinParent.JoinToolViewPort.JoinToolList.forceColumns:TRUE",
"xtv*JoinParent.JoinToolViewPort.JoinToolList.sensitive:FALSE",
"xtv*JoinParent.WJoinTool.label: Join",
"xtv*JoinParent.WJoinTool.fromVert: JoinToolViewPort",
"xtv*JoinParent.WJoinTool.width: 70",
"xtv*JoinParent.WJoinCancel.label: Cancel",
"xtv*JoinParent.WJoinCancel.fromVert: JoinToolViewPort",
"xtv*JoinParent.WJoinCancel.fromHoriz: WJoinTool",
"xtv*JoinParent.WJoinTool.width: 70",
"xtv*JoinParent.WJoinAllTools.label: Join_All",
"xtv*JoinParent.WJoinAllTools.fromVert: WJoinTool",
"xtv*JoinParent.WJoinAllTools.width: 150",
"!",
"xtv*ToolPanel.TermTool.label: Terminate_Tool",
"xtv*ToolPanel.TermTool.sensitive:FALSE",
"xtv*ToolPanel.TermTool.fromVert: GToken",
"xtv*ToolPanel.TermTool.fromHoriz: DToken",
"xtv*ToolPanel.TermTool.foreground: Yellow",
"xtv*ToolPanel.TermTool.background: Red",
"!",
"xtv*value:",
"xtv*NewToolDialog*label: Enter new tool:",
"xtv*NewToolDialog.Host.label: Host",
"xtv*NewToolDialog.Remote.label:Remote",
"xtv*NewToolDialog.CancelNewTool.label:Cancel",
"!The following is the translation needed",
"!to for the dialoge to respond to Carrige Return",
"xtv*NewToolDialog*translations: #override <Key>Return: defaultHost()",
NULL
};
