/* Copyright 1991 NEC Corporation, Tokyo, Japan.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted,
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in
 * supporting documentation, and that the name of NEC Corporation
 * not be used in advertising or publicity pertaining to distribution
 * of the software without specific, written prior permission.  NEC 
 * Corporation makes no representations about the suitability of this
 * software for any purpose.  It is provided "as is" without express
 * or implied warranty.
 *
 * NEC CORPORATION DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN 
 * NO EVENT SHALL NEC CORPORATION BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF 
 * USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR 
 * OTHER TORTUOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR 
 * PERFORMANCE OF THIS SOFTWARE. 
 */

static char rcs_id[] = "@(#) 102.1 $Header: /work/nk.R3.1/lib/iroha/RCS/alphamap.c,v 3.1 91/09/02 13:55:35 kon Exp $";

#include "iroha.h"
#include <iroha/mfdef.h>

#define NONE IROHA_FN_Undefined

extern int AlphaSelfInsert(), JapaneseMode();
extern DoFuncSequence(),UseOtherKeymap();

static int (*alpha_funcs[])() = {
/* ̤                           */    AlphaSelfInsert,
/* ʬȤؿ           */    AlphaSelfInsert,		   
/* ʤؿ         */    AlphaSelfInsert,		   
/* 			    */    NONE,		   
/* ܸϥ⡼                 */    JapaneseMode,	   
/* ե٥åϥ⡼         */    NONE, 		   
/* Ѵϥ⡼                   */    NONE,
/* ѤҤ餬ʳϥ⡼       */    NONE,
/* ѥʳϥ⡼       */    NONE,
/* Ⱦѥʳϥ⡼       */    NONE,
/* ѥե٥åȳϥ⡼ */    NONE,
/* Ⱦѥե٥åȳϥ⡼ */    NONE,
/* ϥ⡼		    */    NONE,
/* ϥ⡼		    */    NONE,
/* ϥ⡼		    */    NONE,
/*                              */    NONE, 		   
/*                              */    NONE,		   
/* ι                           */    NONE, 		   
/* ι                           */    NONE, 		   
/* Ƭ                             */    NONE, 		   
/*                              */    NONE, 		   
/*                              */    NONE,		   
/*                              */    NONE, 		   
/* ޤǺ                     */    NONE, 		 
/* Ѵ                             */    NONE, 		   
/*                              */    NONE, 		   
/* Ф                           */    NONE,		   
/* ̤                             */    NONE, 		   
/* ʸ῭̥⡼ɤ                 */    NONE, 		   
/*                          */    NONE, 		   
/* Ͽ                             */    NONE, 		   
/* ʥɤȤѴ           */    NONE, 		   
/* ̾ȤѴ                 */    NONE,		   
/*                          */    NONE, 		   
/* ʬ̵Ѵ                       */    NONE,		   
/* ѤؤѴ                     */    NONE,		   
/* ȾѤؤѴ                     */    NONE,
/* ʸؤѴ                   */    NONE,
/* ԥ饤                   */    NONE,
/* ʸؤѴ                   */    NONE,
/* Ҥ餬Ѵ			    */	  NONE,
/* Ѵ			    */	  NONE,
/* ޻Ѵ			    */	  NONE,
/* ʣΥγ             */    DoFuncSequence,
/* 󥹤ؤб           */    UseOtherKeymap,
};

unsigned char alpha_kmap[256] =
{               
/* C-@ */       IROHA_FN_SelfInsert,
/* C-a */       IROHA_FN_SelfInsert,
/* C-b */       IROHA_FN_SelfInsert,
/* C-c */       IROHA_FN_SelfInsert,
/* C-d */       IROHA_FN_SelfInsert,
/* C-e */       IROHA_FN_SelfInsert,
/* C-f */       IROHA_FN_SelfInsert,
/* C-g */       IROHA_FN_SelfInsert,
/* C-h */       IROHA_FN_SelfInsert,
/* C-i */       IROHA_FN_SelfInsert,
/* C-j */       IROHA_FN_SelfInsert,
/* C-k */       IROHA_FN_SelfInsert,
/* C-l */       IROHA_FN_SelfInsert,
/* C-m */       IROHA_FN_SelfInsert,
/* C-n */       IROHA_FN_SelfInsert,
/* C-o */       IROHA_FN_JapaneseMode,
/* C-p */       IROHA_FN_SelfInsert,
/* C-q */       IROHA_FN_SelfInsert,
/* C-r */       IROHA_FN_SelfInsert,
/* C-s */       IROHA_FN_SelfInsert,
/* C-t */       IROHA_FN_SelfInsert,
/* C-u */       IROHA_FN_SelfInsert,
/* C-v */       IROHA_FN_SelfInsert,
/* C-w */       IROHA_FN_SelfInsert,
/* C-x */       IROHA_FN_SelfInsert,
/* C-y */       IROHA_FN_SelfInsert,
/* C-z */       IROHA_FN_SelfInsert,
/* C-[ */       IROHA_FN_SelfInsert,
/* C-\ */       IROHA_FN_SelfInsert,
/* C-] */       IROHA_FN_SelfInsert,
/* C-^ */       IROHA_FN_SelfInsert,
/* C-_ */       IROHA_FN_SelfInsert,
/* space */     IROHA_FN_SelfInsert,
/* ! */         IROHA_FN_SelfInsert,
/* " */         IROHA_FN_SelfInsert,
/* # */         IROHA_FN_SelfInsert,
/* $ */         IROHA_FN_SelfInsert,
/* % */         IROHA_FN_SelfInsert,
/* & */         IROHA_FN_SelfInsert,
/* ' */         IROHA_FN_SelfInsert,
/* ( */         IROHA_FN_SelfInsert,
/* ) */         IROHA_FN_SelfInsert,
/* * */         IROHA_FN_SelfInsert,
/* + */         IROHA_FN_SelfInsert,
/* , */         IROHA_FN_SelfInsert,
/* - */         IROHA_FN_SelfInsert,
/* . */         IROHA_FN_SelfInsert,
/* / */         IROHA_FN_SelfInsert,
/* 0 */         IROHA_FN_SelfInsert,
/* 1 */         IROHA_FN_SelfInsert,
/* 2 */         IROHA_FN_SelfInsert,
/* 3 */         IROHA_FN_SelfInsert,
/* 4 */         IROHA_FN_SelfInsert,
/* 5 */         IROHA_FN_SelfInsert,
/* 6 */         IROHA_FN_SelfInsert,
/* 7 */         IROHA_FN_SelfInsert,
/* 8 */         IROHA_FN_SelfInsert,
/* 9 */         IROHA_FN_SelfInsert,
/*   : */       IROHA_FN_SelfInsert,
/* ; */         IROHA_FN_SelfInsert,
/* < */         IROHA_FN_SelfInsert,
/* = */         IROHA_FN_SelfInsert,
/* > */         IROHA_FN_SelfInsert,
/* ? */         IROHA_FN_SelfInsert,
/* @ */         IROHA_FN_SelfInsert,
/* A */         IROHA_FN_SelfInsert,
/* B */         IROHA_FN_SelfInsert,
/* C */         IROHA_FN_SelfInsert,
/* D */         IROHA_FN_SelfInsert,
/* E */         IROHA_FN_SelfInsert,
/* F */         IROHA_FN_SelfInsert,
/* G */         IROHA_FN_SelfInsert,
/* H */         IROHA_FN_SelfInsert,
/* I */         IROHA_FN_SelfInsert,
/* J */         IROHA_FN_SelfInsert,
/* K */         IROHA_FN_SelfInsert,
/* L */         IROHA_FN_SelfInsert,
/* M */         IROHA_FN_SelfInsert,
/* N */         IROHA_FN_SelfInsert,
/* O */         IROHA_FN_SelfInsert,
/* P */         IROHA_FN_SelfInsert,
/* Q */         IROHA_FN_SelfInsert,
/* R */         IROHA_FN_SelfInsert,
/* S */         IROHA_FN_SelfInsert,
/* T */         IROHA_FN_SelfInsert,
/* U */         IROHA_FN_SelfInsert,
/* V */         IROHA_FN_SelfInsert,
/* W */         IROHA_FN_SelfInsert,
/* X */         IROHA_FN_SelfInsert,
/* Y */         IROHA_FN_SelfInsert,
/* Z */         IROHA_FN_SelfInsert,
/* [ */         IROHA_FN_SelfInsert,
/* \ */         IROHA_FN_SelfInsert,
/* ] */         IROHA_FN_SelfInsert,
/* ^ */         IROHA_FN_SelfInsert,
/* _ */         IROHA_FN_SelfInsert,
/* ` */         IROHA_FN_SelfInsert,
/* a */         IROHA_FN_SelfInsert,
/* b */         IROHA_FN_SelfInsert,
/* c */         IROHA_FN_SelfInsert,
/* d */         IROHA_FN_SelfInsert,
/* e */         IROHA_FN_SelfInsert,
/* f */         IROHA_FN_SelfInsert,
/* g */         IROHA_FN_SelfInsert,
/* h */         IROHA_FN_SelfInsert,
/* i */         IROHA_FN_SelfInsert,
/* j */         IROHA_FN_SelfInsert,
/* k */         IROHA_FN_SelfInsert,
/* l */         IROHA_FN_SelfInsert,
/* m */         IROHA_FN_SelfInsert,
/* n */         IROHA_FN_SelfInsert,
/* o */         IROHA_FN_SelfInsert,
/* p */         IROHA_FN_SelfInsert,
/* q */         IROHA_FN_SelfInsert,
/* r */         IROHA_FN_SelfInsert,
/* s */         IROHA_FN_SelfInsert,
/* t */         IROHA_FN_SelfInsert,
/* u */         IROHA_FN_SelfInsert,
/* v */         IROHA_FN_SelfInsert,
/* w */         IROHA_FN_SelfInsert,
/* x */         IROHA_FN_SelfInsert,
/* y */         IROHA_FN_SelfInsert,
/* z */         IROHA_FN_SelfInsert,
/* { */         IROHA_FN_SelfInsert,
/* | */         IROHA_FN_SelfInsert,
/* } */         IROHA_FN_SelfInsert,
/* ~ */         IROHA_FN_SelfInsert,
/* DEL */       IROHA_FN_SelfInsert,
/* Nfer */      IROHA_FN_SelfInsert,
/* Xfer */      IROHA_FN_JapaneseMode,
/* Up */        IROHA_FN_SelfInsert,
/* Left */      IROHA_FN_SelfInsert,
/* Right */     IROHA_FN_SelfInsert,
/* Down */      IROHA_FN_SelfInsert,
/* Insert */    IROHA_FN_SelfInsert,
/* Rollup */    IROHA_FN_SelfInsert,
/* Rolldown */  IROHA_FN_SelfInsert,
/* Home */      IROHA_FN_SelfInsert,
/* Help */      IROHA_FN_SelfInsert,
/* KeyPad */    IROHA_FN_SelfInsert,
/* 8c */        IROHA_FN_SelfInsert,
/* 8d */        IROHA_FN_SelfInsert,
/* 8e */        IROHA_FN_SelfInsert,
/* 8f */        IROHA_FN_SelfInsert,
/* S-nfer */    IROHA_FN_SelfInsert,
/* S-xfer */    IROHA_FN_JapaneseMode,
/* S-up */      IROHA_FN_SelfInsert,
/* S-left */    IROHA_FN_SelfInsert,
/* S-right */   IROHA_FN_SelfInsert,
/* S-down */    IROHA_FN_SelfInsert,
/* C-nfer */    IROHA_FN_SelfInsert,
/* C-xfer */    IROHA_FN_JapaneseMode,
/* C-up */      IROHA_FN_SelfInsert,
/* C-left */    IROHA_FN_SelfInsert,
/* C-right */   IROHA_FN_SelfInsert,
/* C-down */    IROHA_FN_SelfInsert,
/* 9c */        IROHA_FN_SelfInsert,
/* 9d */        IROHA_FN_SelfInsert,
/* 9e */        IROHA_FN_SelfInsert,
/* 9f */        IROHA_FN_SelfInsert,
/* KANASPACE */ IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/*  */        IROHA_FN_SelfInsert,
/* F1 */        IROHA_FN_SelfInsert,
/* F2 */        IROHA_FN_SelfInsert,
/* F3 */        IROHA_FN_SelfInsert,
/* F4 */        IROHA_FN_SelfInsert,
/* F5 */        IROHA_FN_SelfInsert,
/* F6 */        IROHA_FN_SelfInsert,
/* F7 */        IROHA_FN_SelfInsert,
/* F8 */        IROHA_FN_SelfInsert,
/* F9 */        IROHA_FN_SelfInsert,
/* F10 */       IROHA_FN_SelfInsert,
/* ea */        IROHA_FN_SelfInsert,
/* eb */        IROHA_FN_SelfInsert,
/* ec */        IROHA_FN_SelfInsert,
/* ed */        IROHA_FN_SelfInsert,
/* ee */        IROHA_FN_SelfInsert,
/* ef */        IROHA_FN_SelfInsert,
/* PF1 */       IROHA_FN_SelfInsert,
/* PF2 */       IROHA_FN_SelfInsert,
/* PF3 */       IROHA_FN_SelfInsert,
/* PF4 */       IROHA_FN_SelfInsert,
/* PF5 */       IROHA_FN_SelfInsert,
/* PF6 */       IROHA_FN_SelfInsert,
/* PF7 */       IROHA_FN_SelfInsert,
/* PF8 */       IROHA_FN_SelfInsert,
/* PF9 */       IROHA_FN_SelfInsert,
/* PF10 */      IROHA_FN_SelfInsert,
/* fa */        IROHA_FN_SelfInsert,
/* fb */        IROHA_FN_SelfInsert,
/* fc */        IROHA_FN_SelfInsert,
/* fd */        IROHA_FN_SelfInsert,
/* fe */        IROHA_FN_SelfInsert,
/* ff */        IROHA_FN_SelfInsert,
};


KanjiModeRec alpha_mode = {
  simplefunc,
  alpha_kmap,
  IROHA_KANJIMODE_TABLE_SHARED | IROHA_KANJIMODE_EMPTY_MODE,
  alpha_funcs,
};
