/*
 * Copyright 1991 Sony Corporation
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of Sony not be used in advertising or
 * publicity pertaining to distribution of the software without specific,
 * written prior permission.  Sony makes no representations about the
 * suitability of this software for any purpose.  It is provided "as is"
 * without express or implied warranty.
 *
 * SONY DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL SONY
 * BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION
 * OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Noriyuki Hosoe, Sony Corporation
 */

#include "sj_rename.h"
#include "sj_typedef.h"
#include "sj_const.h"
#include "sj_priority.h"


Uchar	termtbl[] = {
	0,
	T_KANOU + P_JOSHI_B,
	T_KANOU + P_JOSHI_A,
	T_KANOU + P_JOSHI_C,
	T_KANOU + P_JOSHI_B,
	T_KANOU + P_JOSHI_C,
	T_KANOU + P_JOSHI_C,
	T_KANOU + P_JOSHI_B,
	T_KANOU + 8,
	T_KANOU + P_JOSHI_B,

	T_KANOU + P_JOSHI_C,
	T_KANOU + P_JOSHI_C,
	T_KANOU + P_JOSHI_B,
	T_KANOU + P_JOSHI_C,
	T_KANOU + P_JOSHI_E,
	T_KANOU + P_JOSHI_B,
	0       + P_FUKA,
	0       + P_FUKA,
	T_KANOU + P_RENYOU_F,
	T_KANOU + P_RENYOU_F,

	T_KANOU + P_RENYOU_F,
	T_KANOU + P_RENYOU_F,
	T_KANOU + P_RENYOU_F,
	T_KANOU + P_RENYOU_F,
	T_KANOU + P_RENYOU_F,
	0       + P_FUKA,
	T_KANOU + P_RENYOU_J,
	T_KANOU + P_RENYOU_J,
	T_KANOU + P_RENYOU_J,
	T_KANOU + P_RENYOU_J,

	T_KANOU + P_RENYOU_M,
	T_KANOU + P_RENYOU_M,
	T_KANOU + P_RENYOU_M,
	T_KANOU + P_RENYOU_M,
	T_KANOU + P_RENYOU_M,
	T_KANOU + P_RENYOU_M,
	0,
	0,
	0,
	T_KANOU + P_RENYOU_J,

	T_KANOU + P_JOSHI_B,
	T_KANOU + P_JOSHI_C,
	T_KANOU + P_RENYOU_J,
	0       + P_FUKA,
	0       + P_FUKA,
	0       + P_FUKA,
	0       + P_FUKA,
	0       + P_FUKA,
	0       + P_FUKA,
	0       + P_FUKA,

	T_KANOU + P_RENYOU_F,
	T_KANOU + P_RENYOU_F,
	T_KANOU + P_RENYOU_F,
	T_KANOU + P_RENYOU_F,
	T_KANOU + P_RENYOU_F,
	T_KANOU + P_RENYOU_F,
	T_KANOU + P_RENYOU_F,
	T_KANOU + P_RENYOU_F,
	T_KANOU + P_RENYOU_F,
	T_KANOU + P_RENYOU_F,

	T_KANOU + P_RENYOU_F,
	T_KANOU + P_RENYOU_F,
	T_KANOU + P_RENYOU_F,
	T_KANOU + P_RENYOU_F,
	T_KANOU + P_RENYOU_F,
	T_KANOU + P_RENYOU_F,
	T_KANOU + P_RENYOU_F,
	0       + P_FUKA,
	T_KANOU + P_JOSHI_C,
	T_KANOU + P_RENYOU_F,

	T_KANOU + P_RENYOU_F,
	T_KANOU + P_RENYOU_F,
	T_KANOU + P_RENYOU_F,
	T_KANOU + P_RENYOU_F,
	T_SHUUJO+ P_SHUUSI,
	T_KANOU + P_SHUUSI,
	T_KANOU + P_SHUUSI,
	T_KANOU + P_SHUUSI,
	T_KANOU + P_SHUUSI,
	T_KANOU + P_SHUUSI,

	T_KANOU + P_SHUUSI,
	T_KANOU + P_SHUUSI,
	T_KANOU + RENTAI + 8,
	T_KANOU + RENTAI + 10,
	T_KANOU + RENTAI + 7,
	T_KANOU + P_SHUUSI,
	T_KANOU + RENTAI + 7,
	T_KANOU + RENTAI + 6,
	T_KANOU + P_SHUUSI,
	T_KANOU + RENTAI + 7,

	T_KANOU + RENTAI + 6,
	T_KANOU + RENTAI + 6,
	T_SHUUJO+ RENTAI + 6,
	T_KANOU + RENTAI + 6,
	T_KANOU + RENTAI + 7,
	T_KANOU + RENTAI + 6,
	T_KANOU + RENTAI + 6,
	T_KANOU + RENTAI + 6,
	T_KANOU + RENTAI + 6,
	T_KANOU + RENTAI + 6,

	0       + P_FUKA,
	T_KANOU + RENTAI + 6,
	0       + P_FUKA,
	T_KANOU + 3,
	0       + P_FUKA,
	0       + P_FUKA,
	T_KANOU + P_KAMEI,
	T_KANOU + P_MEIREI,
	T_KANOU + P_MEIREI,
	T_SHUUJO+ P_MEIREI,
	T_SHUUJO+ P_MEIREI,

	T_KANOU + P_MEISI,
	0       + P_FUKA,
	T_KANOU + P_FUKA,
	T_KANOU + P_MEISI,
	T_KANOU + P_DAIMEISI,
	T_KANOU + P_DAIMEISI,
	T_KANOU + P_MEISI,
	T_KANOU + P_JOSHI_D,
	T_KANOU + P_JOSHI_E,

	T_KANOU + P_SHUUSI,
	T_KANOU + P_DAIMEISI,
	T_KANOU + P_FUKUSI,
	T_KANOU + P_FUKUSI,
	T_KANOU + P_SHUUSI,
	0       + P_FUKA,
	T_KANOU + P_DAIMEISI,
	T_KANOU + 7,
	0       + P_FUKA,
	T_SHUUJO+ P_JOSHI_E,

	T_KANOU + P_JOSHI_B,
	T_KANOU + P_JOSHI_A,
	T_KANOU + P_MEISI,
	T_KANOU + P_JOSHI_B,
	T_KANOU + P_RENYOU_F,
	T_KANOU + P_F_FUKUSI,
	0,
	T_KANOU + P_JOSHI_F,
	0,
	0,

	0       + P_FUKA,
	0       + P_FUKA,
	0       + P_FUKA,
	T_KANOU + P_RENYOU_F,
	T_KANOU + P_RENYOU_J,
	T_KANOU + P_RENYOU_F,
	0       + P_FUKA,
	T_KANOU + P_SHUUSI,
	T_KANOU + P_SHUUSI,
	T_KANOU + P_SHUUSI,

	T_KANOU + P_SHUUSI,
	0       + P_FUKA,
	0       + P_FUKA,
	0       + P_FUKA,
	T_SHUUJO+ P_SHUUSI,
	T_KANOU + P_JOSHI_C,
	T_KANOU + 1,
	T_KANOU + P_JOSHI_F,
	T_KANOU + P_JOSHI_F,
	T_KANOU + P_JOSHI_C,

	T_KANOU + P_JOSHI_C,
	T_KANOU + P_KEISIKI,
	T_KANOU + P_KEISIKI,
	T_KANOU + P_KEISIKI,
	T_KANOU + P_KEISIKI,
	T_KANOU + P_KEISIKI,
	T_KANOU + P_JOSHI_F,
	T_KANOU + P_SHUUSI,
	T_KANOU + P_JOSHI_C,
	T_KANOU + P_JOSHI_C,

	T_KANOU + P_JOSHI_C,
	T_KANOU + P_JOSHI_B,
	T_KANOU + P_JOSHI_D,
	T_KANOU + P_KEISIKI,
	T_KANOU + P_JOSHI_C,
	T_KANOU + P_JOSHI_C,
	T_KANOU + P_JOSHI_C,
	T_KANOU + P_KEISIKI,
	T_KANOU + P_JOSHI_C,
	T_KANOU + P_JOSHI_C,

	T_KANOU + P_KEISIKI,
	T_KANOU + P_JOSHI_D,
	T_KANOU + P_JOSHI_C,
	T_KANOU + P_JOSHI_B,
	T_KANOU + P_KEISIKI,
	T_KANOU + P_JOSHI_D,
	T_KANOU + P_JOSHI_C,
	T_KANOU + P_KEISIKI,
	T_KANOU + P_KEISIKI,
	T_KANOU + P_KEISIKI,

	T_KANOU + P_JOSHI_C,
	T_KANOU + P_KEISIKI,
	T_KANOU + P_JOSHI_C,
	T_KANOU + P_JOSHI_B,
	T_KANOU + P_JOSHI_C,
	T_KANOU + P_JOSHI_D,
	T_KANOU + P_KEISIKI,
	T_KANOU + P_JOSHI_C,
	T_KANOU + P_KEISIKI,
	T_KANOU + P_KEISIKI,

	T_KANOU + P_KEISIKI,
	T_KANOU + P_JOSHI_C,
	T_KANOU + P_JOSHI_C,
	T_KANOU + P_JOSHI_C,
	T_KANOU + P_JOSHI_C,
	T_KANOU + P_KEISIKI,
	T_KANOU + P_KEISIKI,
	T_KANOU + P_KEISIKI,
	T_KANOU + P_JOSHI_C,
	T_KANOU + P_JOSHI_C,

	T_KANOU + P_JOSHI_C,
	T_KANOU + P_JOSHI_C,
	T_KANOU + P_JOSHI_C,
	T_KANOU + P_JOSHI_C,
	T_KANOU + P_JOSHI_C,
	T_KANOU + P_JOSHI_C,
	T_KANOU + P_JOSHI_D,
	T_KANOU + P_JOSHI_D,
	T_KANOU + P_JOSHI_C,
	T_KANOU + P_JOSHI_C,

	T_SHUUJO+ P_SHUUSI,
	T_KANOU + P_JOSHI_C,
	T_KANOU + P_JOSHI_C,
	T_KANOU + P_JOSHI_C,
	T_KANOU + P_JOSHI_C,
	T_KANOU + P_KEISIKI,
	T_KANOU + P_JOSHI_C,
	T_KANOU + P_JOSHI_C,
	T_KANOU + P_KEISIKI,
	T_KANOU + P_KEISIKI,

	T_KANOU + P_JOSHI_C,
	T_KANOU + P_JOSHI_B,
	T_KANOU + P_KEISIKI,
	T_KANOU + P_JOSHI_B,
	T_KANOU + P_KEISIKI,
	T_KANOU + P_KEISIKI,
	T_KANOU + P_JOSHI_C,
	T_KANOU + P_JOSHI_C,
	T_KANOU + P_KEISIKI,
	T_KANOU + P_KEISIKI,

	0       + P_JOSHI_C,
	T_KANOU + P_SUUSI,
	T_KANOU + P_SETUZOKU,
	T_KANOU + P_KANDOU,
	T_KANOU + P_SETTOU,
	T_KANOU + P_FUKUSI,
	T_KANOU + P_FZKKGU,
	T_KANOU + P_MEISI,
	T_KANOU + P_MEISI,
	T_KANOU + P_MEISI,

	T_KANOU + P_MEISI,
	0       + P_SETUBI,
	T_KANOU + P_SETUBI,
	T_KANOU + P_JOSUUSI,
	T_KANOU + P_RENTAISI,
	T_KANOU + P_TANKAN
};
