.\" $Header: XpexCellArray.man,v 2.4 91/09/11 16:03:00 sinyaw Exp $
.\"
.\"
.\" Copyright 1991 by Sony Microsystems Company, San Jose, California
.\" 
.\"                   All Rights Reserved
.\"
.\" Permission to use, modify, and distribute this software and its
.\" documentation for any purpose and without fee is hereby granted,
.\" provided that the above copyright notice appear in all copies and
.\" that both that copyright notice and this permission notice appear
.\" in supporting documentation, and that the name of Sony not be used
.\" in advertising or publicity pertaining to distribution of the
.\" software without specific, written prior permission.
.\"
.\" SONY DISCLAIMS ANY AND ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
.\" INCLUDING ALL EXPRESS WARRANTIES AND ALL IMPLIED WARRANTIES OF
.\" MERCHANTABILITY AND FITNESS, FOR A PARTICULAR PURPOSE. IN NO EVENT
.\" SHALL SONY BE LIABLE FOR ANY DAMAGES OF ANY KIND, INCLUDING BUT NOT
.\" LIMITED TO SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES RESULTING FROM
.\" LOSS OF USE, DATA OR LOSS OF ANY PAST, PRESENT, OR PROSPECTIVE PROFITS,
.\" WHETHER IN AN ACTION OF CONTRACT, NEGLIENCE OR OTHER TORTIOUS ACTION, 
.\" ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS 
.\" SOFTWARE.
.\"
.\" 
.TH XpexCellArray 3PEX "$Revision: 2.4 $" "Sony Microsystems"
.AT
.SH "Name"
XpexCellArray, XpexCellArray2D, XpexExtCellArray \-
.SH "Synopsis"
.nf
void XpexCellArray(dpy, pt1, pt2, pt3, dx, dy, indexed_colors)
.br
	Display \fI*dpy\fP;
.br
	XpexCoord3D \fI*pt1\fP;
.br
	XpexCoord3D \fI*pt2\fP;
.br
	XpexCoord3D \fI*pt3\fP;
.br
	int \fIdx\fP;
.br
	int \fIdy\fP;
.br
	XpexTableIndex *\fIindexed_colors\fP;
.sp
void XpexCellArray2D(dpy, pt1, pt2, dx, dy, indexed_colors)
.br
	Display \fI*dpy\fP;
.br
	XpexCoord2D \fI*pt1\fP;
.br
	XpexCoord2D \fI*pt2\fP;
.br
	int \fIdx\fP;
.br
	int \fIdy\fP;
.br
	XpexTableIndex  \fI*indexed_colors\fP;
.sp
void XpexExtCellArray(dpy, pt1, pt2, pt3, dx, dy, colors_values)
.br
	Display *\fIdpy\fP;
.br
	XpexCoord3D *\fIpt1\fP;
.br
	XpexCoord3D *\fIpt2\fP;
.br
	XpexCoord3D *\fIpt3\fP;
.br
	int \fIdx\fP;
.br
	int \fIdy\fP;
.br
	XpexArrayOfColor *\fIcolors\fP;
.fi
.SH "Arguments"
.IP \fIdpy\fP 1i
Specifies a pointer to the Display structure;
returned from XOpenDisplay.
.SH "Description"
Refer to the PEX Protocol Specification Document, Section 3.
.SH "Structures"
typedef struct {
.br
	XpexTableIndex *color_index;
.br
	XpexFloatColor *color_float;
.br
	XpexRgb8Color *rgb8;
.br
	XpexRgb16Color *rgb16;
.br
} XpexArrayOfColor;
.SH "Errors"
Structure, Renderer, FloatingPointFormat, OutputCommand, Value
.SH "Related Commands"
To be added 
