.\" $Header: XpexCreatePC.man,v 2.5 91/09/11 16:02:35 sinyaw Exp $
.\"
.\" Copyright 1991 by Sony Microsystems Company, San Jose, California
.\" 
.\"                   All Rights Reserved
.\"
.\" Permission to use, modify, and distribute this software and its
.\" documentation for any purpose and without fee is hereby granted,
.\" provided that the above copyright notice appear in all copies and
.\" that both that copyright notice and this permission notice appear
.\" in supporting documentation, and that the name of Sony not be used
.\" in advertising or publicity pertaining to distribution of the
.\" software without specific, written prior permission.
.\"
.\" SONY DISCLAIMS ANY AND ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
.\" INCLUDING ALL EXPRESS WARRANTIES AND ALL IMPLIED WARRANTIES OF
.\" MERCHANTABILITY AND FITNESS, FOR A PARTICULAR PURPOSE. IN NO EVENT
.\" SHALL SONY BE LIABLE FOR ANY DAMAGES OF ANY KIND, INCLUDING BUT NOT
.\" LIMITED TO SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES RESULTING FROM
.\" LOSS OF USE, DATA OR LOSS OF ANY PAST, PRESENT, OR PROSPECTIVE PROFITS,
.\" WHETHER IN AN ACTION OF CONTRACT, NEGLIENCE OR OTHER TORTIOUS ACTION, 
.\" ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS 
.\" SOFTWARE.
.\"
.\" 
.TH XpexCreatePC 3PEX "$Revision: 2.5 $" "Sony Microsystems" 
.AT
.SH "Name"
XpexCreatePC, XpexCopyPC, XpexFreePC \- Manage the creation, freeing,
and copying of pipeline contexts.
.SH "Synopsis"
.nf
XpexPC XpexCreatePC(dpy, valuemask, values)
.br
	Display  *\fIdpy\fP;
.br
	XpexPCBitmask \fIvaluemask\fP;
.br
	XpexPCValues  *\fIvalues\fP;
.sp
void XpexCopyPC(dpy, src_pc_id, dst_pc_id, valuemask)
.br
    Display  *\fIdpy\fP;
.br
    XpexPC  \fIsrc_pc_id\fP;
.br
    XpexPC  \fIdst_pc_id\fP;
.br
    XpexPCBitmask \fIvaluemask\fP;
.sp
void XpexFreePC(dpy, pc_id)
.br
	Display  *\fIdpy\fP;
.br
	XpexPC  \fIpc_id\fP;
.fi
.SH "Arguments"
.IP \fIdpy\fP 
Specifies a pointer to the Display structure;
returned from XOpenDisplay.
.IP \fIvaluemask\fP
Specifies those pipeline context attributes that are to be explicitly
set at the time the resource is created.
.IP \fIvalues\fP
Specifies the structure which contains the values used to modify the 
newly created pipeline context.
.SH "Description"
Refer to the PEX Protocol Specification Document in Section 5.1.
.SH "Structures"
See XpexPCValues(3PEX).
.SH "Errors"
BadIDChoice, 
BadValue, 
BadFloatingPointFormat, 
BadColorType, 
BadAlloc.
.SH "Related Commands"
To be added 
