.\" $Header: XpexCreateRenderer.man,v 2.4 91/09/11 16:01:55 sinyaw Exp $
.\"
.\"
.\" Copyright 1991 by Sony Microsystems Company, San Jose, California
.\" 
.\"                   All Rights Reserved
.\"
.\" Permission to use, modify, and distribute this software and its
.\" documentation for any purpose and without fee is hereby granted,
.\" provided that the above copyright notice appear in all copies and
.\" that both that copyright notice and this permission notice appear
.\" in supporting documentation, and that the name of Sony not be used
.\" in advertising or publicity pertaining to distribution of the
.\" software without specific, written prior permission.
.\"
.\" SONY DISCLAIMS ANY AND ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
.\" INCLUDING ALL EXPRESS WARRANTIES AND ALL IMPLIED WARRANTIES OF
.\" MERCHANTABILITY AND FITNESS, FOR A PARTICULAR PURPOSE. IN NO EVENT
.\" SHALL SONY BE LIABLE FOR ANY DAMAGES OF ANY KIND, INCLUDING BUT NOT
.\" LIMITED TO SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES RESULTING FROM
.\" LOSS OF USE, DATA OR LOSS OF ANY PAST, PRESENT, OR PROSPECTIVE PROFITS,
.\" WHETHER IN AN ACTION OF CONTRACT, NEGLIENCE OR OTHER TORTIOUS ACTION, 
.\" ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS 
.\" SOFTWARE.
.\"
.\" 
.TH XpexCreateRenderer 3PEX "$Revision: 2.4 $" "Sony Microsystems" 
.AT
.SH "Name"
XpexCreateRenderer, XpexFreeRenderer \- Manage the creation and freeing
of renderer resources
.SH "Synopsis"
.nf
XpexRenderer XpexCreateRenderer(dpy, drawable, attr_mask, attributes)
.br
	Display *\fIdpy\fP;
.br
	Drawable \fIdrawable\fP;
.br
	XpexBitmask \fIattr_mask\fP;
.br
	XpexRendererAttributes *\fIattributes\fP;
.sp
void XpexFreeRenderer(dpy, rdr_id)
.br
	Display *\fIdpy\fP;
.br
	XpexRenderer \fIrdr_id\fP;
.fi
.SH "Arguments"
.IP \fIdpy\fP 1i 
Specifies a pointer to the Display structure;
returned from XOpenDisplay.
.IP \fIdrawable\fP 1i
Specifies the drawable.
.IP \fIattr_mask 1i 
Specifies those renderer attributes that are to explicitly 
set at the time the resource is created.
.IP \fIattributes\fP 1i 
To be added
.IP \fIrdr_id\fP 1i
Specifies the renderer to be freed.
.SH "Description"
Refer to the PEX Protocol Specification Document, Section 6.1.
.SH "Structures"
See XpexRendererAttributes(3PEX).
.SH "Errors"
IDChoice, Drawable, PipelineContext, NameSet, LookupTable,
FloatingPointFormat, Value, Alloc, Match
.SH "Related Commands"
To be added 
