.\" $Header: XpexCreateStructure.man,v 2.4 91/09/11 16:02:23 sinyaw Exp $
.\"
.\"
.\" Copyright 1991 by Sony Microsystems Company, San Jose, California
.\" 
.\"                   All Rights Reserved
.\"
.\" Permission to use, modify, and distribute this software and its
.\" documentation for any purpose and without fee is hereby granted,
.\" provided that the above copyright notice appear in all copies and
.\" that both that copyright notice and this permission notice appear
.\" in supporting documentation, and that the name of Sony not be used
.\" in advertising or publicity pertaining to distribution of the
.\" software without specific, written prior permission.
.\"
.\" SONY DISCLAIMS ANY AND ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
.\" INCLUDING ALL EXPRESS WARRANTIES AND ALL IMPLIED WARRANTIES OF
.\" MERCHANTABILITY AND FITNESS, FOR A PARTICULAR PURPOSE. IN NO EVENT
.\" SHALL SONY BE LIABLE FOR ANY DAMAGES OF ANY KIND, INCLUDING BUT NOT
.\" LIMITED TO SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES RESULTING FROM
.\" LOSS OF USE, DATA OR LOSS OF ANY PAST, PRESENT, OR PROSPECTIVE PROFITS,
.\" WHETHER IN AN ACTION OF CONTRACT, NEGLIENCE OR OTHER TORTIOUS ACTION, 
.\" ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS 
.\" SOFTWARE.
.\"
.\" 
.TH XpexCreateStructure 3PEX "$Revision: 2.4 $" "Sony Microsystems"
.AT
.SH "Name"
XpexCreateStructure, XpexCopyStructure, XpexDestroyStructures \- Manage the creation, deletion, and general manipulation of structures
.SH "Synopsis"
.nf
XpexStructure XpexCreateStructure(dpy)
.br
    Display  *dpy;
.sp
void XpexCopyStructure(dpy, src_s_id, dest_s_id)
.br
	Display  *dpy;
.br
	XpexStructure  src_s_id;
.br
	XpexStructure  dest_s_id;
.sp
void XpexDestroyStructures(dpy, s_ids, count)
.br
	Display  *dpy;
.br
	XpexStructure  *s_ids;
.br
	int  count;
.fi
.SH "Arguments"
.IP \fIdpy\fP 1i	
Specifies a pointer to the Display structure;
returned from XOpenDisplay.
.IP \fIsrc_s_id\fP 1i
Specifies the source structure.
.IP \fIdst_s_id\fP 1i
Specifies the destination structure.
.IP \fIs_ids\fP 1i	
Specifies a pointer to an array of structure ids to be deleted.
.IP \fIcount\fP 1i	
Specifies the number of structure ids to be deleted.
.SH "Description"
This function creates a structure resource with the specified 
structure identifier returned.
.SH "Structures"
None
.SH "Errors"
IDChoice, Alloc
.SH "Related Commands"
To be added
