.\" $Header: XpexGetExtensionInfo.man,v 2.4 91/09/11 16:03:13 sinyaw Exp $
.\"
.\" Copyright 1991 by Sony Microsystems Company, San Jose, California
.\" 
.\"                   All Rights Reserved
.\"
.\" Permission to use, modify, and distribute this software and its
.\" documentation for any purpose and without fee is hereby granted,
.\" provided that the above copyright notice appear in all copies and
.\" that both that copyright notice and this permission notice appear
.\" in supporting documentation, and that the name of Sony not be used
.\" in advertising or publicity pertaining to distribution of the
.\" software without specific, written prior permission.
.\"
.\" SONY DISCLAIMS ANY AND ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
.\" INCLUDING ALL EXPRESS WARRANTIES AND ALL IMPLIED WARRANTIES OF
.\" MERCHANTABILITY AND FITNESS, FOR A PARTICULAR PURPOSE. IN NO EVENT
.\" SHALL SONY BE LIABLE FOR ANY DAMAGES OF ANY KIND, INCLUDING BUT NOT
.\" LIMITED TO SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES RESULTING FROM
.\" LOSS OF USE, DATA OR LOSS OF ANY PAST, PRESENT, OR PROSPECTIVE PROFITS,
.\" WHETHER IN AN ACTION OF CONTRACT, NEGLIENCE OR OTHER TORTIOUS ACTION, 
.\" ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS 
.\" SOFTWARE.
.\"
.\" 
.TH XpexGetExtensionInfo 3PEX "$Revision: 2.4 $" "Sony Microsystems"
.AT
.SH "Name"
XpexGetExtensionInfo \- get PEX extension information
.SH "Synopsis"
.nf
Status XpexGetExtensionInfo(dpy, proto_major, proto_minor, extension_info)
.br
	Display *\fIdpy\fP;
.br
	int \fIproto_major\fP;
.br
	int \fIproto_minor\fP;
.br
	XpexExtensionInfo *\fIextension_info\fP; /* RETURN */
.fi
.SH "Arguments"
.IP \fIdpy\fP 1i
Specifies a pointer to the Display structure; returned from
XOpenDisplay.
.IP \fIproto_major\fP 1i
[ To be added ]
.IP \fIproto_minor\fP 1i
[ To be added ]
.IP \fIextension_info\fP 1i
[ To be added ]
.SH "Description"
Refer to the PEX Protocol Specification Document, Section 2.7.1.
.SH "Structures"
typedef struct {
.br
	int proto_major;
.br
	int proto_minor;
.br
	XpexString *vendor;
.br
	int release_number;
.br
	int subset_info;
.br
} XpexExtensionInfo;
.sp
.SH "Errors"
None
.SH "Related Commands"
XpexInitialize, XpexQueryExtension, 
XpexGetEnumTypeInfo, XpexGetImpDepConstants
.br
