.\" $Header: XpexGetNameSet.man,v 2.3 91/09/11 16:03:50 sinyaw Exp $
.\"
.\"
.\" Copyright 1991 by Sony Microsystems Company, San Jose, California
.\" 
.\"                   All Rights Reserved
.\"
.\" Permission to use, modify, and distribute this software and its
.\" documentation for any purpose and without fee is hereby granted,
.\" provided that the above copyright notice appear in all copies and
.\" that both that copyright notice and this permission notice appear
.\" in supporting documentation, and that the name of Sony not be used
.\" in advertising or publicity pertaining to distribution of the
.\" software without specific, written prior permission.
.\"
.\" SONY DISCLAIMS ANY AND ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
.\" INCLUDING ALL EXPRESS WARRANTIES AND ALL IMPLIED WARRANTIES OF
.\" MERCHANTABILITY AND FITNESS, FOR A PARTICULAR PURPOSE. IN NO EVENT
.\" SHALL SONY BE LIABLE FOR ANY DAMAGES OF ANY KIND, INCLUDING BUT NOT
.\" LIMITED TO SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES RESULTING FROM
.\" LOSS OF USE, DATA OR LOSS OF ANY PAST, PRESENT, OR PROSPECTIVE PROFITS,
.\" WHETHER IN AN ACTION OF CONTRACT, NEGLIENCE OR OTHER TORTIOUS ACTION, 
.\" ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS 
.\" SOFTWARE.
.\"
.\" 
.TH XpexGetNameSet 3PEX "$Revision: 2.3 $" "Sony Microsystems" 
.AT
.SH "Name"
XpexGetNameSet, XpexChangeNameSet \- Functions that can be used
to inquire name set resource attributes and modify the contents of name set resources.
.SH "Synopsis"
.nf
Status XpexGetNameSet(dpy, ns_id, names, count)
.br
	Display *\fIdpy\fP;
.br
	XpexNameSet \fIns_id\fP;
.br
	XpexName **\fInames\fP;  /* RETURN */
.br
	int *\fIcount\fP;  /* RETURN */
.sp
void XpexChangeNameSet(dpy, ns_id, action, names, count)
.br
	Display *\fIdpy\fP;
.br
	XpexNameSet \fIns_id\fP;
.br
	int \fIaction\fP;
.br
	XpexName *\fInames\fP;
.br
	int \fIcount\fP;
.fi
.SH "Arguments"
.IP \fIdpy\fP 1i
Specifies a pointer to the Display structure;
returned from XOpenDisplay.
.IP \fIns_id\fP 1i
[ To be added ]
.IP \fInames\fP 1i
[ To be added ]
.IP \fIcount\fP 1i
[ To be added ]
.IP \fIaction\fP 1i	
[ To be added ]
.SH "Description"
The \fIXpexGetNameSet\fP function will return the contents of the 
name set specified by \fIns_id\fP.
.sp
The \fIXpexChangeNameSet\fP function changes the contents of a 
name set resource.  If action is Add, the specified list of names is 
added to the name set.  If action is Remove, the specified list of 
names is removed from the name set.  If action is Replace, all the 
names in the name set are removed, then the specified list of names 
is added to the name set.
.SH "Structures"
None
.SH "Errors"
BadNameSet
.SH "Related Commands"
XpexCreateNameSet, XpexCopyNameSet, XpexFreeNameSet.
