.\" $Header: XpexInitialize.man,v 2.5 91/09/11 16:02:08 sinyaw Exp $
.\"
.\" Copyright 1991 by Sony Microsystems Company, San Jose, California
.\" 
.\"                   All Rights Reserved
.\"
.\" Permission to use, modify, and distribute this software and its
.\" documentation for any purpose and without fee is hereby granted,
.\" provided that the above copyright notice appear in all copies and
.\" that both that copyright notice and this permission notice appear
.\" in supporting documentation, and that the name of Sony not be used
.\" in advertising or publicity pertaining to distribution of the
.\" software without specific, written prior permission.
.\"
.\" SONY DISCLAIMS ANY AND ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
.\" INCLUDING ALL EXPRESS WARRANTIES AND ALL IMPLIED WARRANTIES OF
.\" MERCHANTABILITY AND FITNESS, FOR A PARTICULAR PURPOSE. IN NO EVENT
.\" SHALL SONY BE LIABLE FOR ANY DAMAGES OF ANY KIND, INCLUDING BUT NOT
.\" LIMITED TO SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES RESULTING FROM
.\" LOSS OF USE, DATA OR LOSS OF ANY PAST, PRESENT, OR PROSPECTIVE PROFITS,
.\" WHETHER IN AN ACTION OF CONTRACT, NEGLIENCE OR OTHER TORTIOUS ACTION, 
.\" ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS 
.\" SOFTWARE.
.\"
.\" 
.TH XpexInitialize 3PEX "$Revision: 2.5 $" "Sony Microsystems"
.AT
.SH "Name"
XpexInitialize \- initialize PEX extension
.sp
XpexQueryExtension \- get PEX extension information.
.SH "Synopsis"
.nf
XExtCodes *XpexInitialize(dpy)
.br
	Display *\fIdpy\fP;
.sp
Bool XpexQueryExtension(dpy, major_opcode, first_event, first_error)
.br
	Display	*\fIdpy\fP;
.br
	int *\fImajor_opcode\fP; /* RETURN */
.br
	int *\fIfirst_event\fP; /* RETURN */
.br
	int *\fIfirst_error\fP; /* RETURN */
.fi
.SH "Arguments"
.IP \fIdpy\fP 1i
Specifies a pointer to the Display structure; returned from
XOpenDisplay.
.IP \fImajor_opcode\fP 1i 
Returns the major opcode of the PEX extension, for use in error
handling routines.
.IP \fIfirst_error\fP 1i
Returns the code of the first error defined by the PEX 
extension.
.IP \fIfirst_event\fP 1i
Returns the code of the first custom event defined by the PEX
extension.
.SH "Description"
\fIXpexQueryExtension\fP determines if the PEX extension is present, 
and returns True if it is.  If so, the routines in the PEX extension
can be used just as if they were core Xlib requests, except that they
will return PEX error types.
.SH "Structures"
To be added 
.SH "Errors"
None
.SH "Related Commands"
XpexGetExtensionInfo, XpexGetEnumTypeInfo, XpexGetImpDepConstants.
