.\" $Header: XpexStoreOutputCmds.man,v 2.6 91/09/11 16:04:48 sinyaw Exp $ 
.\"
.\" Copyright 1991 by Sony Microsystems Company, San Jose, California
.\" 
.\"                   All Rights Reserved
.\"
.\" Permission to use, modify, and distribute this software and its
.\" documentation for any purpose and without fee is hereby granted,
.\" provided that the above copyright notice appear in all copies and
.\" that both that copyright notice and this permission notice appear
.\" in supporting documentation, and that the name of Sony not be used
.\" in advertising or publicity pertaining to distribution of the
.\" software without specific, written prior permission.
.\"
.\" SONY DISCLAIMS ANY AND ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
.\" INCLUDING ALL EXPRESS WARRANTIES AND ALL IMPLIED WARRANTIES OF
.\" MERCHANTABILITY AND FITNESS, FOR A PARTICULAR PURPOSE. IN NO EVENT
.\" SHALL SONY BE LIABLE FOR ANY DAMAGES OF ANY KIND, INCLUDING BUT NOT
.\" LIMITED TO SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES RESULTING FROM
.\" LOSS OF USE, DATA OR LOSS OF ANY PAST, PRESENT, OR PROSPECTIVE PROFITS,
.\" WHETHER IN AN ACTION OF CONTRACT, NEGLIENCE OR OTHER TORTIOUS ACTION, 
.\" ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS 
.\" SOFTWARE.
.\"
.\" 
.TH XpexStoreOutputCmds 3PEX "$Revision: 2.6 $" "Sony Microsystems"
.AT
.SH "Name"
XpexStoreOutputCmds, XpexStoreElements, 
XpexDeleteElements, XpexDeleteElementsToLabel, 
XpexDeleteBetweenLabels, XpexCopyElements, XpexChangeStructureRefs \- 
Functions that can be used to modify structure resources
.SH "Synopsis"
.nf
void XpexStoreOutputCmds(dpy, s_id)
.br
	Display  *dpy;
.br
	XpexStructure  s_id;
.sp
void XpexStoreElements(dpy, s_id, num_ocs, length, list)
.br
	Display *dpy;
.br
	XpexStructure s_id;
.br
	int num_ocs;
.br
	int length;
.br
	char *list;
.sp
void XpexDeleteElements(dpy, s_id, range)
.br
	Display  *dpy;
.br
	XpexStructure  s_id;
.br
	XpexElementRange  *range;
.sp
void XpexDeleteElementsToLabel(dpy, s_id, position, label)
.br
	Display  *dpy;
.br
	XpexStructure  s_id;
.br
	XpexElementPos  *position;
.br
	int  label;
.sp
void XpexDeleteBetweenLabels(dpy, s_id, label1, label2)
.br
	Display  *dpy;
.br
	XpexStructure  s_id;
.br
	int  label1; 
.br
	int  label2; 
.sp
void XpexCopyElements(dpy, src_s_id, src_range, dest_s_id, dest_pos)
.br
    Display  *dpy;
.br
	XpexStructure  src_s_id;
.br
	XpexElementRange  *src_range;
.br
	XpexStructure  dest_s_id;
.br
	XpexElementPos  *dest_pos;
.sp
void XpexChangeStructureRefs(dpy, old_s_id, new_s_id)
.br
	Display  *dpy;
.br
	XpexStructure  old_s_id;
.br
	XpexStructure  new_s_id;
.fi
.SH "Arguments"
.IP \fIdpy\fP 1i
Specifies a pointer to the Display structure;
returned from XOpenDisplay.
.IP \fIs_id\fP 1i
To be added
.IP \fIelements\fP 1i
To be added
.IP \fIcount\fP 1i
To be added
.IP \fIrange\fP 1i		
To be added
.IP \fIposition\fP 1i		
To be added
.IP \fIlabel\fP 1i		
To be added
.IP \fIlabel1\fP 1i		
To be added
.IP \fIlabel1\fP 1i		
To be added
.IP \fIsrc_s_id\fP 1i	
To be added
.IP \fIsrc_range\fP 1i	
To be added
.IP \fIdest_s_id\fP 1i	
To be added
.IP \fIdest_pos\fP 1i	
To be added
.IP \fIold_s_id\fP 1i	
To be added
.IP \fInew_s_id\fP 1i	
To be added
.SH "Description"
Refer to the PEX Protocol Specification Document, Section 7.4.
.SH "Structures"
typedef struct {
.br
	XpexElementPos  pos_1;
.br
	XpexElementPos  pos_2;
.br
} XpexElementRange;
.sp
typedef struct {
.br
	int  whence;
.br
	int  offset;
.br
} XpexElementPos;
.SH "Errors"
Structure, FloatingPointFormat, OutputCommand
.SH "Related Commands"
To be added
